routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/home', 'HomeController@index')->name('home');
//Route::get('/',function(){
//    return redirect()->to('/home');
//});
Route::get('new-password', 'Api\Client\AuthController@newPassword');
Route::post('password', 'Api\Client\AuthController@password');
Route::get('/logout', 'Auth\LoginController@logout');
// admin routes
Route::group(['prefix'=> 'admin','middleware'=>'auth'],function(){
    //user reset password
    Route::get('user/change-password','UserController@changePassword');
    Route::post('user/change-password','UserController@changePasswordSave');
    Route::resource('user','UserController');
    //Settings Routes
    Route::get('setting','SettingController@view');
    Route::post('setting','SettingController@update');
    Route::resource('contacts','ContactController',['only' => ['index','destroy','show']]);
    Route::resource('slider', 'SliderController');
        Route::resource('category', 'CategoryController');
    Route::resource('photo', 'PhotoController');
    Route::resource('book','BookController');
    Route::resource('client','ClientController');
    Route::resource('entry','EntryController');
    Route::get('book/{id}/approve', 'BookController@approve');
    Route::get('book/{id}/un-approve', 'BookController@unApprove');
    Route::get('client/{id}/approve', 'ClientController@approve');
    Route::get('client/{id}/un-approve', 'ClientController@unApprove');
});

Route::group(['middleware'=>'language'], function(){
    //Language Controller 
    Route::get('lang/{lang}', 'LanguageController@switchLang');

Route::get('/','FrontController@index');
Route::post('client_login','FrontController@postLogin')->name('client_login');
Route::post('client_register','FrontController@postRegister');
Route::post('client/logout','FrontController@logout');
Route::get('client/entries','FrontController@entries')->name('client.entries');

Route::group(['prefix'=> 'client','middleware'=>'auth:client'],function() {
    Route::get('books','FrontController@books');
    Route::get('book/{id}','FrontController@book');
    Route::get('add_entry/{id}','FrontController@getEntry');
    Route::get('edit_draft/{id}','FrontController@getDraft');
    Route::post('add_entry','FrontController@addEntry');
    Route::get('suggest_book','FrontController@getSuggestBook');
    Route::post('suggest_book','FrontController@suggestBook');
    Route::get('old_work','FrontController@oldWork');
    Route::get('my_entry','FrontController@myEntry');

});
});

app/Models/Client.php
<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class Client extends Authenticatable
{

    use Notifiable;
    protected $guard = 'client';
    protected $table = 'clients';
    public $timestamps = true;
    protected $fillable = array('name', 'speciality','nationality','phone','gender', 'email', 'password','state','api_token','code');
    
    protected  $hidden = ['api_token','code','password', 'remember_token'];
    public function books()
    {
        return $this->hasMany('App\Models\Book');
    }

    public function entries()
    {
        return $this->hasMany('App\Models\Entry');
    }

}

app/Http/Controllers/Api/Client/AuthController.php
<?php

namespace App\Http\Controllers\Api\Client;


use Hash;
use Rule;
use Validator;
use Mail;
use Redirect;
use App\Models\Client;
use App\Mail\VerifyMember;
use App\Mail\resetPassword;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;


class AuthController extends Controller
{

    public function register(Request $request)
    {
        $validation = validator()->make($request->all(), [
            'name' => 'required',
            'city_id' => 'required',
            'password' => 'required|confirmed',
            'mobile' => 'required|unique:clients,mobile',
            'email' => 'required|unique:clients,email',
            'category' => 'required|in:trainer,member,institute,halls_sideboard'
        ]);
        if ($validation->fails()) {
            $data = $validation->errors();
            return responseJson(0, $validation->errors()->first(), $data);
        }
        $Token = str_random(60);
        $code = str_random(6);
        $request->merge(array('code' => $code));
        $request->merge(array('password' => bcrypt($request->password)));
        $request->merge(array('state' => 'unverified'));
        $user = Client::create($request->all());

        if ($request->has('interests')) {
            foreach ($request->interests as $interest) {
                $data = [$interest['id'] => [
                    'client_id' => $user->id,
                ]];
                $user->interests()->attach($data);
            }
        }

        if ($request->has('photos')) {
            $path = base_path();
            foreach ($request->file('photos') as $photo) {
                $destinationPath = $path . '/uploads/clients/'; // upload path
                $extension = $photo->getClientOriginalExtension(); // getting image extension
                $name = time() . '' . rand(11111, 99999) . '.' . $extension; // renameing image
                $photo->move($destinationPath, $name); // uploading file to given path
                $user->photos()->create(['url' => '/uploads/clients/' . $name, 'extension' => $extension]);
            }
        }
        if ($request->has('courses'))
            foreach ($request->courses as $course) {
                $user->trainercourses()->create([
                    'city_id' => $course['city_id'],
                    'center_name' => $course['center_name'],
                    'name' => $course['name']
                ]);
            }
        if ($user) {
            $user->api_token = $Token;
            $user->save();
            $data = [
                'api_token' => $user->api_token,
                'code' => $user->code,
                'user' => $user->fresh()->load('photos', 'specialtie', 'city', 'interests', 'trainercourses')
            ];
            Mail::to($user->email)->send(new VerifyMember($user));
            return responseJson(1, 'تم إنشاء الحساب بنجاح , برجاء فحص بريدك الإلكترونى لتفعيل الحساب', $data);
        } else {
            return responseJson(0, 'خطأ إثناء تسجيل حساب جديد');
        }
    }

    public function verify(Request $request)
    {
        $user = Client::where('code', $request->code)->first();
        if ($user)
        {
            if ($user->state == 'unverified') {
                $user->state = 'confirmed';
                $user->code = null;
                $user->save();
                return view('welcome', ['message' => 'تم تفعيل الحساب بنجاح']);
            } else {
                return view('welcome', ['message' => 'حدث خطأ أثناء تفعيل الحساب']);
            }
        }else{
            return view('welcome', ['message' => 'حدث خطأ أثناء تفعيل الحساب']);
        }
    }


    public function login(Request $request)
    {
        $validation = validator()->make($request->all(), [
            'email' => 'required',
            'password' => 'required'
        ]);
        if ($validation->fails()) {
            $data = $validation->errors();
            return responseJson(0, $validation->errors()->first(), $data);
        }
        $user = Client::where([
            ['email', $request->email],
            ['state', 'confirmed']
        ])->first();

        if ($user) {
            if (Hash::check($request->password, $user->password)) {
                $data = [
                    'api_token' => $user->api_token,
                    'user' => $user
                ];
                return responseJson(1, 'تم تسجيل الدخول بنجاح', $data);
            } else {
                return responseJson(0, 'خطأ أثناء تسجيل الدخول');
            }
        } else {
            return responseJson(0, 'خطأ أثناء تسجيل الدخول');
        }
    }

    public function profile(Request $request)
    {

        $validation = validator()->make($request->all(), [
            'mobile' => 'unique:clients,mobile,' . $request->user()->id,
            'email' => 'unique:clients,email,' . $request->user()->id,

        ]);

        if ($validation->fails()) {
            $data = $validation->errors();
            return responseJson(0, $validation->errors()->first(), $data);
        }

        if ($request->has('name')) {
            $request->user()->update($request->only('name'));
        }


        if ($request->has('email')) {
            $request->user()->update($request->only('email'));
        }

        if ($request->has('mobile')) {
            $request->user()->update($request->only('mobile'));
        }


        if ($request->has('place')) {
            $request->user()->update($request->only('place'));
        }

        if ($request->has('longitude')) {
            $request->user()->update($request->only('longitude'));
        }

        if ($request->has('latitude')) {
            $request->user()->update($request->only('latitude'));
        }

        if ($request->has('about_trainer')) {
            $request->user()->update($request->only('about_trainer'));
        }


        if ($request->has('contact_info')) {
            $request->user()->update($request->only('contact_info'));
        }

        if ($request->has('city_id')) {
            $request->user()->update($request->only('city_id'));
        }

        if ($request->has('specialization_id')) {
            $request->user()->update($request->only('specialization_id'));
        }


        if ($request->has('password')) {
            $request->merge(array('password' => bcrypt($request->password)));
            $request->user()->update($request->only('password'));
        }


        if ($request->user()->category == 'trainer' && $request->hasFile('certifications')) {
            $user = $request->user();
            $path = base_path();
            foreach ($request->file('certifications') as $photo) {
                $destinationPath = $path . '/uploads/clients/'; // upload path
                $extension = $photo->getClientOriginalExtension(); // getting image extension
                $name = time() . '' . rand(11111, 99999) . '.' . $extension; // renameing image
                $photo->move($destinationPath, $name); // uploading file to given path
                $user->photos()->create(['url' => '/uploads/clients/' . $name, 'extension' => $extension]);
            }

        }

        if ($request->has('interests')) {
            foreach ($request->interests as $interest) {
                $data = [$interest['id'] => [
                    'client_id' => $user->id,
                ]];
                $user->interests()->attach($data);
            }
        }


        if ($request->user()->category == 'trainer')
            $data = $request->user()->fresh()->load('specialtie', 'city', 'trainercourses', 'photos');
        if ($request->user()->category == 'member')
            $data = $request->user()->fresh()->load('specialtie', 'city', 'interests', 'registeredCourses');
        if ($request->user()->category == 'institute')
            $data = $request->user()->fresh()->load('specialtie', 'courses', 'photos');
        if ($request->user()->category == 'halls_sideboard')
            $data = $request->user()->fresh()->load('halls', 'photos');


        return responseJson(1, 'تم تحميل البيانات بنجاح', $data);
    }

    /**
     * @param Request $request
     * @return mixed
     */
    public function reset(Request $request)
    {
        $validation = validator()->make($request->all(), [
            'email' => 'required'
        ]);

        if ($validation->fails()) {
            $data = $validation->errors();
            return responseJson(0, $validation->errors()->first(), $data);
        }

        $user = Client::where('email', $request->email)->first();
        if ($user) {
            $code = rand(111111, 999999);
            $update = $user->update(['code' => $code]);
            if ($update) {
                // send email
                Mail::to($user->email)->send(new resetPassword($user));
                return responseJson(1, 'برجاء فحص بريدك الالكتروني');
            } else {
                return responseJson(0, 'حدث خطأ ، حاول مرة أخرى');
            }
        } else {
            return responseJson(0, 'لا يوجد أي حساب مرتبط بهذا البريد الالكتروني');
        }
    }
    public function newPassword(Request $request)
    {
        return view('admin.client.reset-password');
    }

    /**
     * @param Request $request
     * @return mixed
     */
    public function password(Request $request)
    {
        $this->validate($request, [
            'code'        =>'required',
            'old_password' => 'required',
            'password'     => 'required|confirmed',
        ]);
        $user = Client::where('code', $request->code)->first();
        if($user)
        {
            if (Hash::check($request->old_password, $user->password)) {
                if ($request->has('password')) {
                        $user->password = bcrypt($request->password);
                        $user->code = null;
                        $user->save();
                     }

app/Http/Controllers/ClientController.php
<?php

namespace App\Http\Controllers;

use App\Models\Client;
use App\Models\Entry;
use Illuminate\Http\Request;

use App\Http\Requests;

use Response;

class ClientController extends Controller
{
    public function index(Request $request)
    {
        $clients = Client::where(function($q) use($request){
            if($request->name )
            {
                $q->where('name','LIKE','%'.$request->name.'%');
            }

            if($request->email)
            {
                $q->where('email',$request->email);
            }
            if($request->state)
            {
                $q->where('state',$request->state);
            }
        })->latest()->paginate(20);
        return view('admin.clients.index',compact('clients'));
    }

    public function create(Client $model)
    {
        return view('admin.clients.create',compact('model'));

    }

    public function store(Request $request)
    {
        $this->validate($request, [
            'nationality'          => 'required|alpha_dash',
            'speciality'          => 'required|alpha_dash',
            'phone'          => 'required',
            'name'          => 'required|alpha_dash',
            'email'          => 'required|email|unique:clients,email',
            'password'      => 'required|confirmed',
        ]);
        $token = str_random(60);
        $request->merge(array('api_token' => $token));
        $request->merge(array('state' => 'approved'));
        $request->merge(array('password' => bcrypt($request->password)));
        Client::create($request->all());
        flash()->success('  Client has been added successfully');
        return redirect('admin/client');
    }

    public function show($id)
    {
        $client = Client::findorfail($id);
        $entries = Entry::PublishedEntries()->with('book','client')->where('client_id',$client->id)->get();

        return view('admin.clients.show',compact('client','entries'));
    }

    public function edit($id)
    {
        $model = Client::findOrFail($id);
        return view('admin.clients.edit',compact('model'));
    }

    public function update(Request $request , $id)
    {
        $this->validate($request, [
            'nationality'          => 'required|alpha_dash',
            'speciality'          => 'required|alpha_dash',
            'phone'          => 'required',
            'name'          => 'required|alpha_dash',
            'email'          => 'required|email',
            'password'      => 'confirmed',
        ]);
       $client  = Client::findOrFail($id);
        $client->update($request->except('password'));
        if($request->has('password'))
        {
            $client->password = bcrypt($request->password);
        }
        flash()->success('  Client has been updated successfully');
        return redirect('admin/client/'.$id.'/edit');

    }

    public function destroy($id)
    {
        $client = Client::findOrFail($id);

        $client->delete();
        $data = [
            'status' => 1,
            'msg' => '  client has been deleted successfully',
            'id' => $id
        ];
        return Response::json($data, 200);
    }

    public function approve($id)
    {
        $client = Client::findOrFail($id);
        $client->state = 'approved';
        $client->save();
        flash()->success(' client has been activated successfully');
        return back();
    }

    public function unApprove($id)
    {
        $client = Client::findOrFail($id);
        $client->state = 'non_approved';
        $client->save();
        flash()->success(' client has been deactivated successfully');
        return back();
    }
}

resources/views/admin/clients/create.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => 'Clients',
                                'page_description'  => ' New Client'
                                ])
@section('content')
<div class="box box-danger">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>'ClientController@store',
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'POST'
                            ])!!}
    <div class="box-body">
        @include('admin.clients.form')
    </div>
    <div class="box-footer">
        <button type="submit" class="btn btn-primary">save</button>
    </div>
    {!! Form::close()!!}
</div>
@stop

resources/views/admin/clients/edit.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => 'Client',
                                'page_description'  => ' Edit Client'
                                ])

@section('content')
        <!-- FILE: app/views/start.blade.php -->
<div class="box box-danger">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>['ClientController@update',$model->id],
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'PUT'
                            ])!!}
    <div class="box-body">
        @include('admin.clients.form')
    </div>
    <div class="box-footer">
        <button type="submit" class="btn btn-primary">save</button>
    </div>
    {!! Form::close()!!}
</div>
@stop

resources/views/admin/clients/form.blade.php
@include('admin.layouts.partials.validation-errors')
@include('flash::message')

{!! \App\Ibnfarouk\MyClasses\Field::text('name' , ' Full Name') !!}
{!! \App\Ibnfarouk\MyClasses\Field::email('email' , ' Email ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('phone' , ' Phone ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('speciality' , ' Speciality ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('nationality' , ' Nationality ') !!}
<div class="row">
    <div class="col-md-2">
        <label> gender </label>
    </div>
    <div class="col-md-2">
        <label> Male </label>
        {!! Form::radio('gender', 'male', true) !!}
    </div>
    <div class="col-md-2">
        <label>Female</label>
        {!! Form::radio('gender', 'female', false) !!}
    </div>
</div>

{!! \App\Ibnfarouk\MyClasses\Field::password('password','  password') !!}
{!! \App\Ibnfarouk\MyClasses\Field::password('password_confirmation',' password confirmation  ') !!}

resources/views/admin/clients/index.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => 'Clients ',
                                'page_description'  => ' New Client'
                                ])
@section('content')
    <div class="box box-primary">
        <div class="box-body">
                                    @if(auth()->user()->hasRole('admin'))
                <div class="pull-left">
                <a href="{{url('admin/client/create')}}" class="btn btn-primary">
                <i class="fa fa-plus"></i>  New Client
                </a>
            </div>
            @endif
            <div class="clearfix"></div>
            <div class="row">
                {!! Form::open([
                    'method' => 'GET'
                ]) !!}
                <div class="col-md-3">
                    <div class="form-group">
                        <label for="">&nbsp;</label>
                        {!! Form::text('name',\Request::input('name'),[
                            'class' => 'form-control',
                            'placeholder' => ' name '
                        ]) !!}
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <label for="">&nbsp;</label>
                        {!! Form::text('email',\Request::input('email'),[
                            'class' => 'form-control',
                            'placeholder' => 'email  '
                        ]) !!}
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <label for="">&nbsp;</label>
                        {!! Form::select('state',['approved'=>'approved' ,'non_approved'=>'non approved'],\Request::input('state'),
                        [    'class' => 'form-control',
                            'placeholder' => 'state'
                        ]) !!}
                    </div>
                </div>
                <div class="col-md-2">
                    <div class="form-group">
                        <label for="">&nbsp;</label>
                        <button class="btn btn-flat btn-block btn-primary">search</button>
                    </div>
                </div>
                {!! Form::close() !!}
            </div>
            <br>
            @include('flash::message')
            @if(!empty($clients) && count($clients)>0)
                <div class="table-responsive">
                    <table class="data-table table table-bordered">
                        <thead>
                        <th>#</th>
                        <th>Full Name</th>
                        <th>Phone</th>
                        <th>Email </th>
                        @if(auth()->user()->hasRole('admin'))
                            <th class="text-center">Active /  deActive</th>
                            @endif
                        <th class="text-center">Info</th>
                        @if(auth()->user()->hasRole('admin'))
                            <th class="text-center">Edit </th>
                        <th class="text-center">Delete</th>
                            @endif
                        </thead>
                        <tbody>
                        @php $count = 1; @endphp
                        @foreach($clients as $client)
                            <tr id="removable{{$client->id}}">
                                <td>{{$count}}</td>
                                <td>{{$client->name}}</td>
                                <td>{{$client->phone}}</td>
                                <td>{{$client->email}}</td>
                                @if(auth()->user()->hasRole('admin'))
                                <td class="text-center">
                                    @if($client->state == 'approved')
                                        <a href="client/{{$client->id}}/un-approve" class="btn btn-xs btn-danger"><i
                                                    class="fa fa-close"></i> deActivate</a>
                                    @else
                                        <a href="client/{{$client->id}}/approve" class="btn btn-xs btn-success"><i
                                                    class="fa fa-check"></i> Activate</a>
                                    @endif
                                </td>
                                @endif
                                <td class="text-center"><a href="{{url('admin/client/'.$client->id)}}" class="btn btn-xs btn-info"><i class="fa fa-info"></i></a></td>
                                @if(auth()->user()->hasRole('admin'))
                                <td class="text-center">
                                    <a href="client/{{$client->id}}/edit" class="btn btn-xs btn-success"><i class="fa fa-edit"></i></a>
                                </td>

                                <td class="text-center">
                                    <button id="{{$client->id}}" data-token="{{ csrf_token() }}"
                                            data-route="{{URL::route('client.destroy',$client->id)}}"
                                            type="button" class="destroy btn btn-danger btn-xs"><i
                                                class="fa fa-trash-o"></i></button>
                                </td>
                                    @endif
                            </tr>
                            @php $count ++; @endphp
                        @endforeach
                        </tbody>
                    </table>
                </div>
                <div class="text-center">
                    {!! $clients->render() !!}
                </div>
                @else
                <div>
                    <h3 class="text-info" style="text-align: center">No Clients To Show </h3>
                </div>
            @endif
            <div class="clearfix"></div>
        </div>
    </div>
@stop

resources/views/admin/clients/show.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => 'Clients',
                                'page_description'  => 'Client details'
                                ])
@section('content')
    <div class="box box-primary">
        <div class="box-body">
            @include('flash::message')
            <div class="table-responsive">
                <table class="data-table table table-bordered">
                    <tbody>
                    <tr>
                        <td> Client Name</td>
                        <td>{{$client->name}} </td>
                    </tr>

                    <tr>
                        <td> Client Phone</td>
                        <td>{{$client->phone}} </td>
                    </tr>

                    <tr>
                        <td>Client Email</td>
                        <td>{{$client->email ?? '-' }}</td>
                    </tr>
                    <tr>
                        <td> Client Speciality</td>
                        <td>{{$client->speciality}} </td>
                    </tr>

                    <tr>
                        <td> Client Nationality</td>
                        <td>{{$client->nationality}} </td>
                    </tr>
                    <tr>
                        <td> Client Gender</td>
                        <td>{{$client->gender}} </td>
                    </tr>
                    <tr>

                        <td>  state </td>
                        <td>
                            @if($client->state == 'approved')
                                <a href="client/{{$client->id}}/un-approve" class="btn btn-xs btn-danger"><i
                                            class="fa fa-close"></i> deActivate</a>
                            @else
                                <a href="client/{{$client->id}}/approve" class="btn btn-xs btn-success"><i
                                            class="fa fa-check"></i> Activate</a>
                            @endif
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
            <div class="clearfix"></div>
            @if(count($entries)>0)
                <h3>Client Entries</h3>
                <div class="box box-primary">
                    <div class="box-body">
                        <div class="table-responsive">
                            <table class="data-table table table-bordered">
                                <thead>
                                <th>#</th>
                                <th>  book name</th>
                                <th>  summary </th>
                                <th class="text-center">More</th>
                                </thead>
                                <tbody>
                                @foreach($entries as $item)
                                    <tr id="removable{{$item->id}}">
                                        <td>{{$loop->iteration}}</td>
                                        <td><a href="{{url('admin/book/'.$item->book->id) }}">{{$item->book->name ?? '-' }}</a></td>
                                        <td>{{$item->summary ?? '-'  }}</td>
                                        <td class="text-center">
                                            <a href="{{url('admin/entry/'.$item->id )}}" class="btn btn-xs btn-info"><i
                                                        class="fa fa-info-circle"></i></a>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                        <div class="text-center">
                        </div>

                        <div class="clearfix"></div>
                    </div>
                </div>

            @endif
        </div>
    </div>
@stop